/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-groovy-visp-tracker-0.7.5-0precise-20140906-1444/msg/MovingEdgeSettings.msg
 *
 */


#ifndef VISP_TRACKER_MESSAGE_MOVINGEDGESETTINGS_H
#define VISP_TRACKER_MESSAGE_MOVINGEDGESETTINGS_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace visp_tracker
{
template <class ContainerAllocator>
struct MovingEdgeSettings_
{
  typedef MovingEdgeSettings_<ContainerAllocator> Type;

  MovingEdgeSettings_()
    : mask_size(0)
    , n_mask(0)
    , range(0)
    , threshold(0.0)
    , mu1(0.0)
    , mu2(0.0)
    , sample_step(0)
    , ntotal_sample(0)
    , strip(0)
    , min_samplestep(0.0)
    , aberration(0.0)
    , init_aberration(0.0)
    , lambda(0.0)
    , first_threshold(0.0)  {
    }
  MovingEdgeSettings_(const ContainerAllocator& _alloc)
    : mask_size(0)
    , n_mask(0)
    , range(0)
    , threshold(0.0)
    , mu1(0.0)
    , mu2(0.0)
    , sample_step(0)
    , ntotal_sample(0)
    , strip(0)
    , min_samplestep(0.0)
    , aberration(0.0)
    , init_aberration(0.0)
    , lambda(0.0)
    , first_threshold(0.0)  {
    }



   typedef int64_t _mask_size_type;
  _mask_size_type mask_size;

   typedef int64_t _n_mask_type;
  _n_mask_type n_mask;

   typedef int64_t _range_type;
  _range_type range;

   typedef double _threshold_type;
  _threshold_type threshold;

   typedef double _mu1_type;
  _mu1_type mu1;

   typedef double _mu2_type;
  _mu2_type mu2;

   typedef int64_t _sample_step_type;
  _sample_step_type sample_step;

   typedef int64_t _ntotal_sample_type;
  _ntotal_sample_type ntotal_sample;

   typedef int64_t _strip_type;
  _strip_type strip;

   typedef double _min_samplestep_type;
  _min_samplestep_type min_samplestep;

   typedef double _aberration_type;
  _aberration_type aberration;

   typedef double _init_aberration_type;
  _init_aberration_type init_aberration;

   typedef double _lambda_type;
  _lambda_type lambda;

   typedef double _first_threshold_type;
  _first_threshold_type first_threshold;




  typedef boost::shared_ptr< ::visp_tracker::MovingEdgeSettings_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::visp_tracker::MovingEdgeSettings_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct MovingEdgeSettings_

typedef ::visp_tracker::MovingEdgeSettings_<std::allocator<void> > MovingEdgeSettings;

typedef boost::shared_ptr< ::visp_tracker::MovingEdgeSettings > MovingEdgeSettingsPtr;
typedef boost::shared_ptr< ::visp_tracker::MovingEdgeSettings const> MovingEdgeSettingsConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::visp_tracker::MovingEdgeSettings_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::visp_tracker::MovingEdgeSettings_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace visp_tracker

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/groovy/share/std_msgs/cmake/../msg'], 'sensor_msgs': ['/opt/ros/groovy/share/sensor_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/groovy/share/geometry_msgs/cmake/../msg'], 'visp_tracker': ['/tmp/buildd/ros-groovy-visp-tracker-0.7.5-0precise-20140906-1444/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::visp_tracker::MovingEdgeSettings_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::visp_tracker::MovingEdgeSettings_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::visp_tracker::MovingEdgeSettings_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::visp_tracker::MovingEdgeSettings_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::visp_tracker::MovingEdgeSettings_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::visp_tracker::MovingEdgeSettings_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::visp_tracker::MovingEdgeSettings_<ContainerAllocator> >
{
  static const char* value()
  {
    return "376fefab194f3282c421288b8a099b76";
  }

  static const char* value(const ::visp_tracker::MovingEdgeSettings_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x376fefab194f3282ULL;
  static const uint64_t static_value2 = 0xc421288b8a099b76ULL;
};

template<class ContainerAllocator>
struct DataType< ::visp_tracker::MovingEdgeSettings_<ContainerAllocator> >
{
  static const char* value()
  {
    return "visp_tracker/MovingEdgeSettings";
  }

  static const char* value(const ::visp_tracker::MovingEdgeSettings_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::visp_tracker::MovingEdgeSettings_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# This message contains tracking parameters.\n\
#\n\
# These parameters determine how precise, how fast and how\n\
# reliable will be the tracking.\n\
#\n\
# It should be tuned carefully and can be changed dynamically.\n\
#\n\
# For more details, see the ViSP documentation:\n\
# http://www.irisa.fr/lagadic/visp/publication.html\n\
\n\
\n\
# Moving edge parameters.\n\
\n\
int64 mask_size    # Mask size (in pixel) used to compute the image gradient\n\
                   # and determine the object contour.\n\
		   # A larger mask size is better for larger images.\n\
		   # 3 pixels is enough for 640x480 images.\n\
                   # Increasing this value makes the tracking slower.\n\
		   #\n\
		   # Caution: this value cannot be changed dynamically\n\
		   # without resetting the tracking.\n\
\n\
int64 n_mask       # Number of masks applied to determine the object contour.\n\
                   # Increasing this value makes the tracking slower.\n\
\n\
int64 range        # Maximum seek distance on both sides of the reference pixel.\n\
      		   # It should match the maximum distance in pixel between\n\
		   # the current position of the feature projection and\n\
		   # its next position.\n\
		   # I.e. if the object moves fast and your tracking\n\
		   # frequency is low, this value should be increased.\n\
                   # Increasing this value makes the tracking slower.\n\
\n\
float64 threshold  # Value used to determine if a moving edge is valid\n\
		   # or not.\n\
\n\
float64 mu1        # Minimum image contrast allowed to detect a contour.\n\
float64 mu2        # Maximum image contrast allowed to detect a contour.\n\
\n\
int64 sample_step   # Minimum distance in pixel between two\n\
      		    # discretization points.\n\
      		    # It avoids having too many discretization points when\n\
		    # the tracked object is far away (and its projection\n\
		    # in the image is small).\n\
		    # Increasing this value makes the tracking *faster*.\n\
\n\
int64 ntotal_sample # How many discretization points are used to track the\n\
      		    # feature.\n\
		    # Higher is better but slow down the tracking.\n\
		    # The best value depends on your model and its distance\n\
		    # with respect to the camera.\n\
		    # Increasing this value makes the tracking slower.\n\
\n\
int64 strip             # How many pixels are ignored around the borders.\n\
float64 min_samplestep  # Minimum allowed samplestep. Useful to specify\n\
			# a lower bound when the samplestep is changed\n\
			# dynamically.\n\
			# This is not done by visp_tracker currently.\n\
float64 aberration      # Ignored.\n\
float64 init_aberration # Ignored.\n\
\n\
\n\
# Tracker parameters.\n\
\n\
float64 lambda          # Gain used to compute the control law.\n\
float64 first_threshold # What proportion of points should be valid to\n\
                        # acccept an initial pose.\n\
			# Value should be between 0 et 1.\n\
\n\
";
  }

  static const char* value(const ::visp_tracker::MovingEdgeSettings_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::visp_tracker::MovingEdgeSettings_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.mask_size);
      stream.next(m.n_mask);
      stream.next(m.range);
      stream.next(m.threshold);
      stream.next(m.mu1);
      stream.next(m.mu2);
      stream.next(m.sample_step);
      stream.next(m.ntotal_sample);
      stream.next(m.strip);
      stream.next(m.min_samplestep);
      stream.next(m.aberration);
      stream.next(m.init_aberration);
      stream.next(m.lambda);
      stream.next(m.first_threshold);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct MovingEdgeSettings_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::visp_tracker::MovingEdgeSettings_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::visp_tracker::MovingEdgeSettings_<ContainerAllocator>& v)
  {
    s << indent << "mask_size: ";
    Printer<int64_t>::stream(s, indent + "  ", v.mask_size);
    s << indent << "n_mask: ";
    Printer<int64_t>::stream(s, indent + "  ", v.n_mask);
    s << indent << "range: ";
    Printer<int64_t>::stream(s, indent + "  ", v.range);
    s << indent << "threshold: ";
    Printer<double>::stream(s, indent + "  ", v.threshold);
    s << indent << "mu1: ";
    Printer<double>::stream(s, indent + "  ", v.mu1);
    s << indent << "mu2: ";
    Printer<double>::stream(s, indent + "  ", v.mu2);
    s << indent << "sample_step: ";
    Printer<int64_t>::stream(s, indent + "  ", v.sample_step);
    s << indent << "ntotal_sample: ";
    Printer<int64_t>::stream(s, indent + "  ", v.ntotal_sample);
    s << indent << "strip: ";
    Printer<int64_t>::stream(s, indent + "  ", v.strip);
    s << indent << "min_samplestep: ";
    Printer<double>::stream(s, indent + "  ", v.min_samplestep);
    s << indent << "aberration: ";
    Printer<double>::stream(s, indent + "  ", v.aberration);
    s << indent << "init_aberration: ";
    Printer<double>::stream(s, indent + "  ", v.init_aberration);
    s << indent << "lambda: ";
    Printer<double>::stream(s, indent + "  ", v.lambda);
    s << indent << "first_threshold: ";
    Printer<double>::stream(s, indent + "  ", v.first_threshold);
  }
};

} // namespace message_operations
} // namespace ros

#endif // VISP_TRACKER_MESSAGE_MOVINGEDGESETTINGS_H
